
#ifndef LBX_STRBUF_H
#define LBX_STRBUF_H

#ifndef  LBX_STR_REALLOC_EX /* client could override */
#define LBX_STR_REALLOC_EX 4096;
#endif

typedef struct string_buffer 
{
	long long size;
	long long len;
	char *str;
} strbuf;

typedef strbuf* string_buffer_t;

string_buffer_t create_string_buffer(long long sz);
int delete_string_buffer(string_buffer_t sb);
long long clear_string_buffer(string_buffer_t sb);
long long append_buffer(string_buffer_t sb, const char* str);
long long append_buffer_n(string_buffer_t sb, long long size, const char* str);
long long append_buffer_fmt(string_buffer_t sb, long long size, const char *fmt, ...);

#endif /* LBX_STRBUF_H */
